//    Copyright (c) 2016  Forschungszentrum Juelich GmbH
//                        Markus Brenneis, Vladislav Kotov 
//
//    This file is part of EIRAM.
//
//    EIRAM is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    EIRAM is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with EIRAM.  If not, see <http://www.gnu.org/licenses/>.

#ifndef eiram_octave_hpp
#define eiram_octave_hpp

#include <octave/f77-fcn.h>

/**
 * Header file containing interfaces for Fortran subroutines in eiram_interfaces.f90 for use in Octave.
 * 
 * For documentation of the functions, see eiram_interfaces.
 * 
 * The macros provided by Octave ensure that the interface works with most compilers.
 */
extern "C" {
    F77_RET_T
    F77_FUNC (eiram_matlab_calc2, FORTSUB)
        (double[],
         double[], double[], 
         int&,int&,
         F77_CONST_CHAR_ARG_DECL,
         F77_CONST_CHAR_ARG_DECL,
         F77_CONST_CHAR_ARG_DECL,
         int&
         F77_CHAR_ARG_LEN_DECL F77_CHAR_ARG_LEN_DECL F77_CHAR_ARG_LEN_DECL
        );
    
    F77_RET_T
    F77_FUNC (eiram_matlab_calc1, FORTSUB)
        (double[], double[], int&,
         F77_CONST_CHAR_ARG_DECL,
         F77_CONST_CHAR_ARG_DECL,
         F77_CONST_CHAR_ARG_DECL,
         int&
         F77_CHAR_ARG_LEN_DECL F77_CHAR_ARG_LEN_DECL F77_CHAR_ARG_LEN_DECL
        );
       
    F77_RET_T
    F77_FUNC (eiram_load_wrapper, FORTSUB)
        (F77_CONST_CHAR_ARG_DECL, F77_CONST_CHAR_ARG_DECL, int& F77_CHAR_ARG_LEN_DECL F77_CHAR_ARG_LEN_DECL);
    
    F77_RET_T
    F77_FUNC (eiram_deallocate_wrapper, FORTSUB)
        (int&);
}

#endif
